package
{
	import flash.display.BitmapData;
	import flash.display.MovieClip;
	import flash.geom.Rectangle;
	import flash.ui.Mouse;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;

	public class GameState extends FlxState
	{
		
		public function GameState()
		{
			Mouse.show();
			super();
		}

		public static var srcImage:BitmapData;
		public var bgCanvas:FlxSprite;
		public var fgImage:FlxSprite;

		public const buttonsize:Number=8;
		
		public var b1:FlxButton;
		public var b2:FlxButton;
		public var b3:FlxButton;
		public var b4:FlxButton;
		public var b5:FlxButton;
		
		public var b6:FlxButton;
		public var b7:FlxButton;
		public var b8:FlxButton;
		
		
		public var mode:int;
		
		
		public function onClick1():void
		{							
			
			mode=1;
			b1.on=true;
			b2.on=false;
			b3.on=false;
			b4.on=false;
			b5.on=false;
		}
		
		public function onClick2():void
		{
			mode=2;
			b1.on=false;
			b2.on=true;
			b3.on=false;
			b4.on=false;
			b5.on=false;
		}
		
		public function onClick3():void
		{
			mode=3;
			b1.on=false;
			b2.on=false;
			b3.on=true;
			b4.on=false;
			b5.on=false;
		}
		
		public function onClick4():void
		{
			mode=4;			
			b1.on=false;
			b2.on=false;
			b3.on=false;
			b4.on=true;
			b5.on=false;
		}
		
		public function onClick5():void
		{
			mode=5;			
			b1.on=false;
			b2.on=false;
			b3.on=false;
			b4.on=false;
			b5.on=true;
		}
		
		
		
		public function onClick6():void
		{
			size=4;			
			b6.on=true;
			b7.on=false;
			b8.on=false;
		}
		
		public function onClick7():void
		{
			size=5;			
			b6.on=false;
			b7.on=true;
			b8.on=false;
		}
		
		public function onClick8():void
		{
			size=12;			
			b6.on=false;
			b7.on=false;
			b8.on=true;
		}
		
		public var size:int;
		
		override public function create():void
		{
			
			
			bgCanvas = new FlxSprite(0,0);
			bgCanvas.createGraphic(FlxG.width,FlxG.height,0xff000000);
			
			this.add(bgCanvas);
			
	
			srcImage = ResizeImage.resizeIt(srcImage,FlxG.width-buttonsize,FlxG.height);
			fgImage = new FlxSprite(buttonsize,0);
			fgImage.pixels=srcImage;
			this.add(fgImage);
			
			var n:int = 10+ Math.random()*10;
			for (var i:int=0;i<n;i++)
			{
				var x:Number=Math.random()*FlxG.width;
				var y:Number=Math.random()*FlxG.height; 
				var r1:Number=10+Math.random()*10;
				var r2:Number=10+Math.random()*10;
				
				fgImage._pixels.fillRect(new Rectangle(x-r1,y-r2,2*r1,2*r2),0x00000000);;
			}			
			fgImage.resetHelpers();
											
			var s:FlxSprite;
			var t:FlxSprite;
			var u:FlxSprite;
			var lbl:FlxText;
			
			b1 = new FlxButton(0,(buttonsize+2)*0,onClick1);
			s = new FlxSprite(0,0);
			s.solid=false;
			s.createGraphic(buttonsize,buttonsize,0xffff0000);
			
			t = new FlxSprite(0,0);
			t.solid=false;
			t.createGraphic(buttonsize,buttonsize,0xffff5555);
			b1.loadGraphic(s,t);
			b1.add(u);
			lbl = new FlxText(-2,-2,buttonsize,"1");
			lbl.size=6;
			lbl.color=0xffffff00;
			b1.add(lbl);
			this.add(b1);
			
			
			b2 = new FlxButton(0,(buttonsize+2)*1,onClick2);
			s = new FlxSprite(0,0);
			s.solid=false;
			s.createGraphic(buttonsize,buttonsize,0xff00ff00);
			
			t = new FlxSprite(0,0);
			t.solid=false;
			t.createGraphic(buttonsize,buttonsize,0xff55ff55);
			b2.loadGraphic(s,t);
			b2.add(u);
			lbl = new FlxText(-2,-2,buttonsize,"2");
			lbl.size=6;
			lbl.color=0xffffff00;
			b2.add(lbl);
			this.add(b2);
			
			
			b3 = new FlxButton(0,(buttonsize+2)*2,onClick3);
			s = new FlxSprite(0,0);
			s.solid=false;
			s.createGraphic(buttonsize,buttonsize,0xff0000ff);
			
			t = new FlxSprite(0,0);
			t.solid=false;
			t.createGraphic(buttonsize,buttonsize,0xff5555ff);
			b3.loadGraphic(s,t);
			lbl = new FlxText(-2,-2,buttonsize,"3");
			lbl.size=6;
			lbl.color=0xffffff00;
			b3.add(lbl);
			this.add(b3);
			
			
			b4 = new FlxButton(0,(buttonsize+2)*3,onClick4);
			s = new FlxSprite(0,0);
			s.solid=false;
			s.createGraphic(buttonsize,buttonsize,0xffbbbbbb);
			
			t = new FlxSprite(0,0);
			t.solid=false;
			t.createGraphic(buttonsize,buttonsize,0xffffffff);
			b4.loadGraphic(s,t);
			lbl = new FlxText(-2,-2,buttonsize,"4");
			lbl.size=6;
			lbl.color=0xffffff00;
			b4.add(lbl);
			this.add(b4);
			
			
			mode=4;
			b4.on=true;
			
			b5 = new FlxButton(0,(buttonsize+2)*4,onClick5);
			s = new FlxSprite(0,0);
			s.solid=false;
			s.createGraphic(buttonsize,buttonsize,0xff333333);
			
			t = new FlxSprite(0,0);
			t.solid=false;
			t.createGraphic(buttonsize,buttonsize,0xff555555);
			b5.loadGraphic(s,t);
			lbl = new FlxText(-2,-2,buttonsize,"5");
			lbl.size=6;
			lbl.color=0xffffff00;
			b5.add(lbl);
			this.add(b5);	
			
																							
			b6 = new FlxButton(0,(buttonsize+2)*6,onClick6);
			s = new FlxSprite(0,0);
			s.solid=false;
			s.createGraphic(buttonsize,buttonsize,0xff777777);
			
			t = new FlxSprite(0,0);
			t.solid=false;
			t.createGraphic(buttonsize,buttonsize,0xffaaaaaa);
			b6.loadGraphic(s,t);
			lbl = new FlxText(-2,-2,buttonsize,"S");
			lbl.size=6;
			lbl.color=0xffffff00;
			b6.add(lbl);
			this.add(b6);
			
			
			b7 = new FlxButton(0,(buttonsize+2)*7,onClick7);
			s = new FlxSprite(0,0);
			s.solid=false;
			s.createGraphic(buttonsize,buttonsize,0xff777777);
			
			t = new FlxSprite(0,0);
			t.solid=false;
			t.createGraphic(buttonsize,buttonsize,0xffaaaaaa);
			b7.loadGraphic(s,t);
			lbl = new FlxText(-2,-2,buttonsize,"M");
			lbl.size=6;
			lbl.color=0xffffff00;
			b7.add(lbl);
			this.add(b7);
			
			
			b8 = new FlxButton(0,(buttonsize+2)*8,onClick8);
			s = new FlxSprite(0,0);
			s.solid=false;
			s.createGraphic(buttonsize,buttonsize,0xff777777);
			
			t = new FlxSprite(0,0);
			t.solid=false;
			t.createGraphic(buttonsize,buttonsize,0xffaaaaaa);
			b8.loadGraphic(s,t);
			lbl = new FlxText(-2,-2,buttonsize,"L");
			lbl.size=6;
			lbl.color=0xffffff00;
			b8.add(lbl);
			this.add(b8);
			
			size=4;
			b7.on=true;
		}
		
		override public function update():void
		{
			
			if  (FlxG.keys.justPressed("ONE"))
			{
				this.onClick1();
			}
			if  (FlxG.keys.justPressed("TWO"))
			{
				this.onClick2();
			}
			if  (FlxG.keys.justPressed("THREE"))
			{
				this.onClick3();
			}
			if  (FlxG.keys.justPressed("FOUR"))
			{
				this.onClick4();
			}
			if  (FlxG.keys.justPressed("FIVE"))
			{
				this.onClick5();
			}
			if (FlxG.keys.justPressed("S"))
			{
				this.onClick6();
			}
			if (FlxG.keys.justPressed("M"))
			{
				this.onClick7();
			}
			if (FlxG.keys.justPressed("L"))
			{
				this.onClick8();
			}
			
			if (FlxG.mouse.pressed() && FlxG.mouse.x>11)
			{
				var col:uint;
				switch (mode)
				{
					case 1:
						col=0xffff0000;
						break;
					case 2:
						col=0xff00ff00;
						break;
					case 3:
						col=0xff0000ff;
						break;
					case 4:
						col=0xffffffff;
						break;
					case 5:
						col=0xff000000;
						break;
				}
			
				bgCanvas._pixels.fillRect(new Rectangle(FlxG.mouse.x-size/2,FlxG.mouse.y-size/2,size,size),col);
				bgCanvas.resetHelpers();
			}
			super.update();
		}

	}
}